% substrate and butyrate inhibtions in butyrate fermenter
% butanol inhibition in butanol fermenter
% no cell death
% no cell maintanance

function dxdt = kineticSystemBuOH(t,x,B) 

dxdt = zeros(size(x));

%butanol fermentation model
%dx/dt x(1)=x1 Biomass 1
dxdt(1) = x(1) * (B(1)*x(2)/(B(2)+x(2))) * (17.7 / (17.7+x(5)));

rs = (1/B(3))*(B(1)*x(2)/(B(2)+x(2)));

%ds1/dt x(2)=s1 Substrate 1
dxdt(2) = -x(1) * rs;

%dBA/dt x(3)=HBu Butyric acid 1
dxdt(3) = x(1) * (B(4)*rs - B(5)*x(3)/(B(6)+x(3)));

%dAA/dt x(4)=Acetic acid 1
dxdt(4) = x(1) * (B(7)*rs - B(8)*x(4)/(B(9)+x(4)));

%dB/dt x(5)=BuOH Butanol
dxdt(5) = x(1) * (B(10)*rs + B(11)*x(3)/(B(6)+x(3))); %- ((D(1)*x(5)*x(10) / (D(2)*D(3) + D(3)*x(5) + D(4)*x(10) + x(5)*x(10)))*x(12));

%dA/dt x(6)=Acetone
dxdt(6) = x(1) * (B(12)*rs + B(13)*x(4)/(B(9)+x(4)));

%dE/dt x(7)=Ethanol
dxdt(7) = B(14)*x(1)*rs;

%the rest of the dxdts are zeros

%{
%butyric acid fermentation model
%dx/dt x(8)=x2 Biomass 2
dxdt(8) = x(8) * (C(1)*x(9)/(C(2)+x(9)+(x(9)^2/372))*(1-x(10)/48.3)^5.18);

%ds2/dt x(9)=s2 Substrate 2

%dBA/dt x(10)=HBu Butyric acid 2
dxdt(10) = C(6)*dxdt(8) + C(7)*x(8) - ((D(1)*x(5)*x(10) / (D(2)*D(3) + D(3)*x(5) + D(4)*x(10) + x(5)*x(10)))*x(12));

%dAA/dt x(11)=Acetic acid 2
dxdt(11) = C(8)*dxdt(8) + C(9)*x(8);

dxdt(9) = -(1/C(3)*dxdt(8) + 1/C(4)*dxdt(10) + 1/C(5)*dxdt(11) + 2*44.01/88.1*(1/C(4)*dxdt(10)) + 1*44.01/60.05*(1/C(5)*dxdt(11)));

%butyl butyrate esterification model
%dBuB/dt x(12)=BuB Butyl butyrate
dxdt(12) = (D(1)*x(5)*x(10) / (D(2)*D(3) + D(3)*x(5) + D(4)*x(10) + x(5)*x(10))); %two substrate Michaelis_Menten
%}

end
