clear variables
close all
clc
%{
Vyu = csvread('dataGridVy.csv');
rCSTRu = csvread('datarCSTR.csv');
Vx = Vxu./((Vxu.^2 + Vyu.^2).^0.5);%normalize, even though this is already done
Vy = Vyu./((Vxu.^2 + Vyu.^2).^0.5);
rCSTR = zeros(size(rCSTRu));
rCSTR(:,1) = rCSTRu(:,1)./((rCSTRu(:,1).^2 + rCSTRu(:,2).^2).^.5);
rCSTR(:,2) = rCSTRu(:,2)./((rCSTRu(:,1).^2 + rCSTRu(:,2).^2).^.5);
%}

%% Import the data

dirCSV = [pwd, '/optARdata'];
dirPlots = [pwd, '/plots'];

addpath(dirCSV)
cPFRall = csvread([dirCSV, '/dataPFRallf.csv']);%PFR from feed
cCSTRall = csvread([dirCSV, '/dataCSTRall.csv']);%CSTR from feed
cPFR{1} = cPFRall(:, [3, end]);
cCSTR = cCSTRall(:, [3, end]);
cAll = csvread([dirCSV, '/dataCall.csv']);%all data
hullVertices = csvread([dirCSV, '/hullVertices.csv']);%vertices of the convex hull
hullVertices = hullVertices + 1;%adjust for python indexation
%extract data for quiver plots
Xq = csvread([dirCSV, '/dataGridX.csv']); %Xgrid
Yq = csvread([dirCSV, '/dataGridY.csv']); %Xgrid
Vxq = csvread([dirCSV, '/dataGridVx.csv']); %Xgrid
Vyq = csvread([dirCSV, '/dataGridVy.csv']); %Xgrid
scaleArrow = 1;
Vxq = Vxq.*scaleArrow;
Vyq = Vyq.*scaleArrow;
rmpath(dirCSV)


%% Do the plotting

%Main AR plot (fig1)
fig{1} = figure(1);
ax1 = fig{1}.CurrentAxes;
xlabel('C_{BuB} [g/L]')
ylabel('\tau [h]')
%title('AR HBu')
mhs = 0.01;%MaxHeadSize
%q = quiver(X,Y,Vx,Vy, 'MaxHeadSize', mhs);
%q.Color = [184, 185, 177]./255;
alpha(0.2)
hold on
PFR = 1;%indices in the cell where the plotting lines are stored
CSTR = 2;
mix = 3;
PFR2 = 4;
fillHull = 5;
rateField = 6;
l = {};%storage for lines
l{CSTR} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'bx');
l{PFR}{1} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
    'Color', [1,0,0,1], 'LineWidth', .1);%set the color as [r,g,b,alpha]
lim = axis;%this and the nextlines are for fixing the limits on the axis 
lim(end) = max(cAll(:,2)); % set ylim_max to maximum value of the filled
%region (the convex hull)
axis(lim);
%fill the area of the convex hull
rgbFill = [0.12156863, 0.46666667, 0.70588235];%desired rgb color
l{fillHull} = fill(cAll(hullVertices, 1), cAll(hullVertices, 2), rgbFill);
set(l{fillHull}, 'facealpha', .2, 'edgealpha', .2)%make transparent


%draw the rate vector field
l{rateField} = quiver(Xq, Yq, Vxq, Vyq, 0);%argument 0 turns off automatic scaling
l{rateField}.MaxHeadSize = mhs;%mhs defined on line 45 (moght be moved later)
l{rateField}.Color = [184, 185, 177]./255;%make them greyish (kindof transparent)

%{
for i = PFR:CSTR%1:2, PFR, CSTR
    set(l{i}, 'Visible', 'off')
end	
%}
%redraw the "operation lines" so that they are on top of i.e the rate field
l{CSTR} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'b*');
l{PFR}{1} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
    'Color', [1,0,0,1], 'LineWidth', .1);%set the color as [r,g,b,alpha]
xl = xlim;
xlim([0, xl(2)])
yl = ylim;
ylim([0, yl(2)])
legend([l{PFR}{1}, l{CSTR}], [{'PFR'}, {'CSTR'}], ...
   'location', 'NorthEast')
% legend([l{PFR}{1}, l{CSTR}], [{'PFR'}, {'CSTR'}], ...
%     'location', 'NorthEast')


%% Save the figures

addpath(dirPlots)
saveas(figure(fig{1}), [dirPlots, '/ARMatlab'], 'epsc')
saveas(figure(fig{2}), [dirPlots, '/multipleCSTRsol'], 'epsc')

%these steps are required to save the pdf as not the whole page, only the
%picture
fig{1}.PaperPositionMode = 'auto';
fig_pos = fig{1}.PaperPosition;
fig{1}.PaperSize = [fig_pos(3) fig_pos(4)];
print(fig{1},[dirPlots, '/ARMatlab'],'-dpdf')


rmpath(dirPlots)
