clear variables; close all; clc;

if ispc
    dir.home = [getenv('HOMEDRIVE') getenv('HOMEPATH')];
else
    dir.home = getenv('HOME');
end
%dir 2 python csvs
dir.csv = [dir.home, '/Dropbox/Masteroppgave/PythonFiles/bioProcessButylButyrate/scenario2-sep blocks/bubBlockFinerGrid/resBub'];
%import the projection
projection2d = csvread([dir.csv, '/projectionBuohHBu.csv']);
fileNumPointsGrid = fopen([dir.csv, '/numPointsGrid.txt'], 'r'); %contains one number
w = textscan(fileNumPointsGrid, '%f');%open as a floating point number. w is a dummy (cell) variable
np = w{1}; % number of points in the grid
fclose(fileNumPointsGrid);

%Make the mesh in the 2d space
%np = 20; %number of points in the mesh
xm = linspace(0, max(projection2d(:, 1)), np)'; 
ym = linspace(0, max(projection2d(:, 2)), np)';
zm = zeros(np, 1);
[Xm, Ym] = meshgrid(xm,ym);
Zm = zeros(size(Xm));
%determine which points of the mesh which are inside the 2d projection
in = inpolygon(Xm, Ym, projection2d(:,1), projection2d(:,2));
Zm(~in) = NaN;
Xm(~in) = NaN;
Ym(~in) = NaN;

plt = true; %make a plot of the region and mesh to ensure that the mesh is ok
if plt
    figure
    hold on
    region.myMesh = mesh(Xm,Ym,Zm, 'Marker', 'o', 'MeshStyle', 'None',...
        'MarkerFaceColor', 'k', 'MarkerEdgeColor', 'k', 'MarkerSize', 3);
    patch(projection2d(:,1), projection2d(:,2), projection2d(:,3), ...
        'FaceColor', 'k', 'FaceAlpha', .2);
end
    % write the mesh to a csv file so that it may be used in python

csvwrite([dir.csv, '/Xm.csv'], Xm);
csvwrite([dir.csv, '/Ym.csv'], Ym);
csvwrite([dir.csv, '/Zm.csv'], Zm);
