clear variables
close all
clc
%{
Vyu = csvread('dataGridVy.csv');
rCSTRu = csvread('datarCSTR.csv');
Vx = Vxu./((Vxu.^2 + Vyu.^2).^0.5);%normalize, even though this is already done
Vy = Vyu./((Vxu.^2 + Vyu.^2).^0.5);
rCSTR = zeros(size(rCSTRu));
rCSTR(:,1) = rCSTRu(:,1)./((rCSTRu(:,1).^2 + rCSTRu(:,2).^2).^.5);
rCSTR(:,2) = rCSTRu(:,2)./((rCSTRu(:,1).^2 + rCSTRu(:,2).^2).^.5);
%}

%% Import the data

dirCSV = [pwd, '/computedCSV'];
dirPlots = [pwd, '/plots'];

addpath(dirCSV)
cPFR{1} = csvread([dirCSV, '/dataPFRf.csv']);%PFR from feed
cCSTR = csvread([dirCSV, '/dataCSTR.csv']);%CSTR from feed
cAll = csvread([dirCSV, '/dataCall.csv']);%all data
hullVertices = csvread([dirCSV, '/hullVertices.csv']);%vertices of the convex hull
hullVertices = hullVertices + 1;%adjust for python indexation
%extract data for quiver plots
Xq = csvread([dirCSV, '/dataGridX.csv']); %Xgrid
Yq = csvread([dirCSV, '/dataGridY.csv']); %Xgrid
Vxq = csvread([dirCSV, '/dataGridVx.csv']); %Xgrid
Vyq = csvread([dirCSV, '/dataGridVy.csv']); %Xgrid
scaleArrow = 1;
Vxq = Vxq.*scaleArrow;
Vyq = Vyq.*scaleArrow;
rmpath(dirCSV)


mline = [cCSTR(1, :); cPFR{1}(end, :)];%mixing line


%% Do the plotting

%Main AR plot (fig1)
fig{1} = figure(1);
ax1 = fig{1}.CurrentAxes;
xlabel('C_{S} [g/L]')
ylabel('C_{BuOH} [g/L]')
%title('AR BuOH')
mhs = 0.01;%MaxHeadSize
%q = quiver(X,Y,Vx,Vy, 'MaxHeadSize', mhs);
%q.Color = [184, 185, 177]./255;
%alpha(0.2)
hold on
PFR = 1;%indices in the cell where the plotting lines are stored
CSTR = 2;
mix = 3;
PFR2 = 4;
fillHull = 5;
rateField = 6;
l = {};%storage for lines
l{CSTR} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'b*');
l{PFR}{1} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
    'Color', [1,0,0,1]);%set the color as [r,g,b,alpha]
l{mix} = plot(mline(:, 1), mline(:, 2), 'k');

lim = axis;%this and the nextlines are for fixing the limits on the axis 
lim(end) = max(cAll(:,2)); % set ylim_max to maximum value of the filled
%region (the convex hull)
axis(lim);
%fill the area of the convex hull
rgbFill = [0.12156863, 0.46666667, 0.70588235];%desired rgb color
l{fillHull} = fill(cAll(hullVertices, 1), cAll(hullVertices, 2), rgbFill);
set(l{fillHull}, 'facealpha', .2, 'edgealpha', .2)%make transparent


%draw the rate vector field
l{rateField} = quiver(Xq, Yq, Vxq, Vyq, 0);%argument 0 turns off automatic scaling
l{rateField}.MaxHeadSize = mhs;%mhs defined on line 45 (moght be moved later)
l{rateField}.Color = [184, 185, 177]./255;%make them greyish (kindof transparent)

%{
for i = PFR:CSTR%1:2, PFR, CSTR
    set(l{i}, 'Visible', 'off')
end	
%}
%redraw the "operation lines" so that they are on top of i.e the rate field
l{CSTR} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'b*');
l{PFR}{1} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
    'Color', [1,0,0,1], 'LineWidth', .1);%set the color as [r,g,b,alpha]
l{mix} = plot(mline(:, 1), mline(:, 2), 'k');
xl = xlim;
xlim([0, xl(2)])
yl = ylim;
ylim([0, yl(2)])
legend([l{PFR}{1} l{CSTR}, l{mix}], [{'PFR'}, {'CSTR'}, {'Mix'}], ...
    'location', 'NorthEast')
set(gca, 'FontSize', 12)

%make a plot on a new axis inside the original plot
axes('position',[.5 .65 .25 .25])
hold on
xlim([0,5])
ylim([9,10])
l{7} = fill(cAll(hullVertices, 1), cAll(hullVertices, 2), rgbFill);
set(l{7}, 'facealpha', .2, 'edgealpha', .2)%make transparent
l{8} = quiver(Xq, Yq, Vxq, Vyq, 0);%argument 0 turns off automatic scaling
l{8}.MaxHeadSize = mhs;%mhs defined on line 45 (moght be moved later)
l{8}.Color = [184, 185, 177]./255;%make them greyish (kindof transparent)
l{9} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'b*');
l{10} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
    'Color', [1,0,0,1], 'LineWidth', .1);%set the color as [r,g,b,alpha]
l{11} = plot(mline(:, 1), mline(:, 2), 'k');

box on % put box around new pair of axes

axis tight%RUN THE NEXT LINES IN THE COMMAND WINDOWS AFTERWARDS
% ylim([10.599,10.6])
% xlim([0.01,.018])
% yticks([10.599, 10.6])
% xticks([0.01, 0.014, 0.018])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% t = linspace(0,2*pi,1000); % values in time
% x = cos(t); % a sinusoid
% perturbation = 0.1*exp((-(t-5*pi/4).^2)/.01).*sin(200*t); % a perturbation
% signal = x+perturbation; % a signal to plot
% % plot signal on new figure
% figure,plot(t,x+perturbation)
% xlabel('time'),ylabel('signal')
% % create a new pair of axes inside current figure
% axes('position',[.65 .175 .25 .25])
% box on % put box around new pair of axes
% indexOfInterest = (t < 11*pi/8) & (t > 9*pi/8); % range of t near perturbation
% plot(t(indexOfInterest),signal(indexOfInterest)) % plot on new axes
% axis tight


%{
for p = 2:8:length(cCSTR(:,1))
    line = [cCSTR(1,1), cCSTR(1,2);
        cCSTR(p,1), cCSTR(p,2)];
    plot(line(:,1), line(:,2), 'b--')
end
quiver(cCSTR(:,1),cCSTR(:,2),rCSTR(:,1),rCSTR(:,2),'b', 'MaxHeadSize', mhs)
%}
xl = xlim;
xlim([0, xl(2)])
yl = ylim;
ylim([0, yl(2)])
legend([l{PFR}{1} l{CSTR}, l{mix}], [{'PFR'}, {'CSTR'}, {'Mix'}], ...
    'location', 'NorthEast')
set(gca, 'FontSize', 12)
%legend BOXOFF
%{
% create a new pair of axes inside current figure
ax2 = axes('position',[.2 .3 .25 .25]);
box on % put box around new pair of axes
%xlim([0, 0.04])
%ylim([0, 0.15])
%(re)plot the data inside the new axes
scatter(cCSTR(:, 1), cCSTR(:, 2), ...
    'b*', 'SizeData', 15) % plot on new axes
hold on
plot(cPFR(:, 1), cPFR(:, 2), ...
    'Color', [1,0,0,1], 'LineWidth', 1)

%(re)fill the convex hull
h2(1) = fill(cAll(hullVertices, 1), cAll(hullVertices, 2), rgbFill);
set(h2(1), 'facealpha', .2, 'edgealpha', .2)%make transparent

%(re)draw the rate vector field on the small axis
h2(2) = quiver(Xq, Yq, Vxq, Vyq, 0);%argument 0 turns off automatic scaling
h2(2).MaxHeadSize = mhs;%mhs defined on line 45 (moght be moved later)
h2(2).Color = [184, 185, 177]./255;%make them greyish (kindof transparent)
ax2;
set(ax2, 'XLim',[0, 0.04])
set(ax2, 'YLim',[0, 0.15])
axis tight
%}


%% Save the figures

addpath(dirPlots)
saveas(figure(fig{1}), [dirPlots, '/ARMatlab'], 'epsc')

%these steps are required to save the pdf as not the whole page, only the
%picture
fig{1}.PaperPositionMode = 'auto';
fig_pos = fig{1}.PaperPosition;
fig{1}.PaperSize = [fig_pos(3) fig_pos(4)];
print(fig{1},[dirPlots, '/ARMatlab'],'-dpdf')

rmpath(dirPlots)
