clear variables
close all
clc
%{
Vyu = csvread('dataGridVy.csv');
rCSTRu = csvread('datarCSTR.csv');
Vx = Vxu./((Vxu.^2 + Vyu.^2).^0.5);%normalize, even though this is already done
Vy = Vyu./((Vxu.^2 + Vyu.^2).^0.5);
rCSTR = zeros(size(rCSTRu));
rCSTR(:,1) = rCSTRu(:,1)./((rCSTRu(:,1).^2 + rCSTRu(:,2).^2).^.5);
rCSTR(:,2) = rCSTRu(:,2)./((rCSTRu(:,1).^2 + rCSTRu(:,2).^2).^.5);
%}

%% Import the data

dirCSV = [pwd, '/computedCSV'];
dirPlots = [pwd, '/plots'];

addpath(dirCSV)
cPFR{1} = csvread([dirCSV, '/dataPFRf.csv']);%PFR from feed
cCSTR = csvread([dirCSV, '/dataCSTR.csv']);%CSTR from feed
cPFR{2} = csvread([dirCSV, '/dataPFR2.csv']);%2nd PFR, after mixing
cAll = csvread([dirCSV, '/dataCall.csv']);%all data
hullVertices = csvread([dirCSV, '/hullVertices.csv']);%vertices of the convex hull
hullVertices = hullVertices + 1;%adjust for python indexation
%extract data for quiver plots
Xq = csvread([dirCSV, '/dataGridX.csv']); %Xgrid
Yq = csvread([dirCSV, '/dataGridY.csv']); %Xgrid
Vxq = csvread([dirCSV, '/dataGridVx.csv']); %Xgrid
Vyq = csvread([dirCSV, '/dataGridVy.csv']); %Xgrid
scaleArrow = 1;
Vxq = Vxq.*scaleArrow;
Vyq = Vyq.*scaleArrow;
rmpath(dirCSV)


fileOptimCSTR = fopen([dirCSV, '/optimCSTRindex.txt'], 'r'); %contains one number
w = textscan(fileOptimCSTR, '%f');%open as a floating point number
optimCSTRIndex = w{1} + 1;%contains only one number. +1 for difference in 
%indexation from python to matlab
fclose(fileOptimCSTR);

mline = [cCSTR(1, :); cCSTR(optimCSTRIndex, :)];%mixing line


%% Do the plotting

%Main AR plot (fig1)
fig{1} = figure(1);
ax1 = fig{1}.CurrentAxes;
xlabel('C_{S} [g/L]')
ylabel('\tau [h]')
%title('AR HBu')
mhs = 0.01;%MaxHeadSize
%q = quiver(X,Y,Vx,Vy, 'MaxHeadSize', mhs);
%q.Color = [184, 185, 177]./255;
alpha(0.2)
hold on
PFR = 1;%indices in the cell where the plotting lines are stored
CSTR = 2;
mix = 3;
PFR2 = 4;
fillHull = 5;
rateField = 6;
l = {};%storage for lines
%l{CSTR} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'b*');
% l{PFR}{1} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
%     'Color', [1,0,0,1], 'LineWidth', .1);%set the color as [r,g,b,alpha]
l{PFR}{2} = plot(cPFR{2}(:, 1), cPFR{2}(:, 2),...PFR from feed
    'Color', [1,0,0,1], 'LineWidth', 1);%set the color as [r,g,b,alpha]
l{mix} = plot(mline(:, 1), mline(:, 2), 'k');
l{CSTR} = scatter(mline(end, 1), mline(end, 2), 'bx');
lim = axis;%this and the nextlines are for fixing the limits on the axis 
lim(end) = max(cAll(:,2)); % set ylim_max to maximum value of the filled
%region (the convex hull)
axis(lim);
%fill the area of the convex hull
rgbFill = [0.12156863, 0.46666667, 0.70588235];%desired rgb color
l{fillHull} = fill(cAll(hullVertices, 1), cAll(hullVertices, 2), rgbFill);
set(l{fillHull}, 'facealpha', .2, 'edgealpha', .2)%make transparent


%draw the rate vector field
l{rateField} = quiver(Xq, Yq, Vxq, Vyq, 0);%argument 0 turns off automatic scaling
l{rateField}.MaxHeadSize = mhs;%mhs defined on line 45 (moght be moved later)
l{rateField}.Color = [184, 185, 177]./255;%make them greyish (kindof transparent)

%{
for i = PFR:CSTR%1:2, PFR, CSTR
    set(l{i}, 'Visible', 'off')
end	
%}
%redraw the "operation lines" so that they are on top of i.e the rate field
%l{CSTR} = scatter(cCSTR(:, 1), cCSTR(:, 2), 'b*');
% l{PFR}{1} = plot(cPFR{1}(:, 1), cPFR{1}(:, 2),...PFR from feed
%     'Color', [1,0,0,1], 'LineWidth', .1);%set the color as [r,g,b,alpha]
l{PFR}{2} = plot(cPFR{2}(:, 1), cPFR{2}(:, 2),...PFR from feed
    'Color', [1,0,0,1], 'LineWidth', 1);%set the color as [r,g,b,alpha]
l{mix} = plot(mline(:, 1), mline(:, 2), 'k');
l{CSTR} = scatter(mline(end, 1), mline(end, 2), 'bx');
lim = axis;%this and the nextlines are for fixing the limits on the axis 
lim(end) = max(cAll(:,2)); % set ylim_max to maximum value of the filled
%{
for p = 2:8:length(cCSTR(:,1))
    line = [cCSTR(1,1), cCSTR(1,2);
        cCSTR(p,1), cCSTR(p,2)];
    plot(line(:,1), line(:,2), 'b--')
end
quiver(cCSTR(:,1),cCSTR(:,2),rCSTR(:,1),rCSTR(:,2),'b', 'MaxHeadSize', mhs)
%}
xl = xlim;
xlim([0, xl(2)])
yl = ylim;
ylim([0, yl(2)])
legend([l{PFR}{2}, l{CSTR}, l{mix}], [{'PFR'}, {'CSTR'}, {'Mix'}], ...
   'location', 'NorthEast')
% legend([l{PFR}{1}, l{CSTR}], [{'PFR'}, {'CSTR'}], ...
%     'location', 'NorthEast')
%legend BOXOFF
%{
% create a new pair of axes inside current figure
ax2 = axes('position',[.2 .3 .25 .25]);
box on % put box around new pair of axes
%xlim([0, 0.04])
%ylim([0, 0.15])
%(re)plot the data inside the new axes
scatter(cCSTR(:, 1), cCSTR(:, 2), ...
    'b*', 'SizeData', 15) % plot on new axes
hold on
plot(cPFR(:, 1), cPFR(:, 2), ...
    'Color', [1,0,0,1], 'LineWidth', 1)

%(re)fill the convex hull
h2(1) = fill(cAll(hullVertices, 1), cAll(hullVertices, 2), rgbFill);
set(h2(1), 'facealpha', .2, 'edgealpha', .2)%make transparent

%(re)draw the rate vector field on the small axis
h2(2) = quiver(Xq, Yq, Vxq, Vyq, 0);%argument 0 turns off automatic scaling
h2(2).MaxHeadSize = mhs;%mhs defined on line 45 (moght be moved later)
h2(2).Color = [184, 185, 177]./255;%make them greyish (kindof transparent)
ax2;
set(ax2, 'XLim',[0, 0.04])
set(ax2, 'YLim',[0, 0.15])
axis tight
%}
%% Check if the CSTR have several solutions

dirCSV = [pwd, '/computedCSV'];

addpath(dirCSV)
tvRes = csvread([dirCSV, '/solCSTRtv.csv']);%check for multiple CSTR solutions
cvRes = csvread([dirCSV, '/solCSTRcv.csv']);%check for multiple CSTR solutions
resRes = csvread([dirCSV, '/solCSTRres.csv']);%check for multiple CSTR solutions
rmpath(dirCSV)

fig{2} = figure(2);
surf(tvRes,cvRes,resRes) %resRes is the solution of the equation
% resRes = (cvRes-cf) + rxRate(cvRes)*tvRes
hold on
xlabel('\tau [h]')
ylabel('C_S [g/L]')
zlabel('Residual CSTR design equation')
xl = xlim;
yl = ylim;
[xm2, ym2] = meshgrid(xl, yl);%make a meshgrid
zm2 = zeros(size(xm2));
hSurf = surf(xm2, ym2, zm2);
set(hSurf, 'FaceColor', [1,0,0], 'EdgeColor', [1,0,0], 'FaceAlpha', .2,...
    'EdgeAlpha', .2)


%% Save the figures

addpath(dirPlots)
saveas(figure(fig{1}), [dirPlots, '/ARMatlab'], 'epsc')
saveas(figure(fig{2}), [dirPlots, '/multipleCSTRsol'], 'epsc')

%these steps are required to save the pdf as not the whole page, only the
%picture
fig{1}.PaperPositionMode = 'auto';
fig_pos = fig{1}.PaperPosition;
fig{1}.PaperSize = [fig_pos(3) fig_pos(4)];
print(fig{1},[dirPlots, '/ARMatlab'],'-dpdf')


fig{2}.PaperPositionMode = 'auto';
fig_pos = fig{2}.PaperPosition;
fig{2}.PaperSize = [fig_pos(3) fig_pos(4)];
print(fig{2},[dirPlots, '/multipleCSTRsol'],'-dpdf')
rmpath(dirPlots)
